// $Id$

/*************************************************************************
 * XDAQ Components for Distributed Data Acquisition                      *
 * Copyright (C) 2000-2009, CERN.			                 *
 * All rights reserved.                                                  *
 * Authors: J. Gutleber and L. Orsini					 *
 *                                                                       *
 * For the licensing terms see LICENSE.		                         *
 * For the list of contributors see CREDITS.   			         *
 *************************************************************************/

#ifndef _WebEnvironment_h_
#define _WebEnvironment_h_

#include "xdaq/WebApplication.h"
//#include "xgi/Utils.h"
#include "xgi/Method.h"

//#include "cgicc/CgiDefs.h"
//#include "cgicc/Cgicc.h"
//#include "cgicc/HTTPHTMLHeader.h"
#include "cgicc/HTMLClasses.h"

class WebEnvironment: public xdaq::Application 
{
	public:
	
	XDAQ_INSTANTIATOR();
	
	WebEnvironment(xdaq::ApplicationStub * s) ;
	
	void Default(xgi::Input * in, xgi::Output * out ) ;
};

#endif
