
/**
 * This is a generated class and is not intended for modification.  
 */
package valueObjects
{
import com.adobe.fiber.styles.IStyle;
import com.adobe.fiber.styles.Style;
import com.adobe.fiber.styles.StyleValidator;
import com.adobe.fiber.valueobjects.AbstractEntityMetadata;
import com.adobe.fiber.valueobjects.AvailablePropertyIterator;
import com.adobe.fiber.valueobjects.IPropertyIterator;
import mx.collections.ArrayCollection;
import mx.events.ValidationResultEvent;
import valueObjects.Definition;
import com.adobe.fiber.core.model_internal;
import com.adobe.fiber.valueobjects.IModelType;
import mx.events.PropertyChangeEvent;

use namespace model_internal;

[ExcludeClass]
internal class _TableEntityMetadata extends com.adobe.fiber.valueobjects.AbstractEntityMetadata
{
    private static var emptyArray:Array = new Array();

    model_internal static var allProperties:Array = new Array("definition", "rows");
    model_internal static var allAssociationProperties:Array = new Array();
    model_internal static var allRequiredProperties:Array = new Array("definition", "rows");
    model_internal static var allAlwaysAvailableProperties:Array = new Array("definition", "rows");
    model_internal static var guardedProperties:Array = new Array();
    model_internal static var dataProperties:Array = new Array("definition", "rows");
    model_internal static var sourceProperties:Array = emptyArray
    model_internal static var nonDerivedProperties:Array = new Array("definition", "rows");
    model_internal static var derivedProperties:Array = new Array();
    model_internal static var collectionProperties:Array = new Array("definition", "rows");
    model_internal static var collectionBaseMap:Object;
    model_internal static var entityName:String = "Table";
    model_internal static var dependentsOnMap:Object;
    model_internal static var dependedOnServices:Array = new Array();
    model_internal static var propertyTypeMap:Object;

    
    model_internal var _definitionIsValid:Boolean;
    model_internal var _definitionValidator:com.adobe.fiber.styles.StyleValidator;
    model_internal var _definitionIsValidCacheInitialized:Boolean = false;
    model_internal var _definitionValidationFailureMessages:Array;
    
    model_internal var _rowsIsValid:Boolean;
    model_internal var _rowsValidator:com.adobe.fiber.styles.StyleValidator;
    model_internal var _rowsIsValidCacheInitialized:Boolean = false;
    model_internal var _rowsValidationFailureMessages:Array;

    model_internal var _instance:_Super_Table;
    model_internal static var _nullStyle:com.adobe.fiber.styles.Style = new com.adobe.fiber.styles.Style();

    public function _TableEntityMetadata(value : _Super_Table)
    {
        // initialize property maps
        if (model_internal::dependentsOnMap == null)
        {
            // dependents map
            model_internal::dependentsOnMap = new Object();
            model_internal::dependentsOnMap["definition"] = new Array();
            model_internal::dependentsOnMap["rows"] = new Array();

            // collection base map
            model_internal::collectionBaseMap = new Object();
            model_internal::collectionBaseMap["definition"] = "valueObjects.Definition";
            model_internal::collectionBaseMap["rows"] = "Object";
        }

        // Property type Map
        model_internal::propertyTypeMap = new Object();
        model_internal::propertyTypeMap["definition"] = "ArrayCollection";
        model_internal::propertyTypeMap["rows"] = "ArrayCollection";

        model_internal::_instance = value;
        model_internal::_definitionValidator = new StyleValidator(model_internal::_instance.model_internal::_doValidationForDefinition);
        model_internal::_definitionValidator.required = true;
        model_internal::_definitionValidator.requiredFieldError = "definition is required";
        //model_internal::_definitionValidator.source = model_internal::_instance;
        //model_internal::_definitionValidator.property = "definition";
        model_internal::_rowsValidator = new StyleValidator(model_internal::_instance.model_internal::_doValidationForRows);
        model_internal::_rowsValidator.required = true;
        model_internal::_rowsValidator.requiredFieldError = "rows is required";
        //model_internal::_rowsValidator.source = model_internal::_instance;
        //model_internal::_rowsValidator.property = "rows";
    }

    override public function getEntityName():String
    {
        return model_internal::entityName;
    }

    override public function getProperties():Array
    {
        return model_internal::allProperties;
    }

    override public function getAssociationProperties():Array
    {
        return model_internal::allAssociationProperties;
    }

    override public function getRequiredProperties():Array
    {
         return model_internal::allRequiredProperties;   
    }

    override public function getDataProperties():Array
    {
        return model_internal::dataProperties;
    }

    public function getSourceProperties():Array
    {
        return model_internal::sourceProperties;
    }

    public function getNonDerivedProperties():Array
    {
        return model_internal::nonDerivedProperties;
    }

    override public function getGuardedProperties():Array
    {
        return model_internal::guardedProperties;
    }

    override public function getUnguardedProperties():Array
    {
        return model_internal::allAlwaysAvailableProperties;
    }

    override public function getDependants(propertyName:String):Array
    {
       if (model_internal::nonDerivedProperties.indexOf(propertyName) == -1)
            throw new Error(propertyName + " is not a data property of entity Table");
            
       return model_internal::dependentsOnMap[propertyName] as Array;  
    }

    override public function getDependedOnServices():Array
    {
        return model_internal::dependedOnServices;
    }

    override public function getCollectionProperties():Array
    {
        return model_internal::collectionProperties;
    }

    override public function getCollectionBase(propertyName:String):String
    {
        if (model_internal::collectionProperties.indexOf(propertyName) == -1)
            throw new Error(propertyName + " is not a collection property of entity Table");

        return model_internal::collectionBaseMap[propertyName];
    }
    
    override public function getPropertyType(propertyName:String):String
    {
        if (model_internal::allProperties.indexOf(propertyName) == -1)
            throw new Error(propertyName + " is not a property of Table");

        return model_internal::propertyTypeMap[propertyName];
    }

    override public function getAvailableProperties():com.adobe.fiber.valueobjects.IPropertyIterator
    {
        return new com.adobe.fiber.valueobjects.AvailablePropertyIterator(this);
    }

    override public function getValue(propertyName:String):*
    {
        if (model_internal::allProperties.indexOf(propertyName) == -1)
        {
            throw new Error(propertyName + " does not exist for entity Table");
        }

        return model_internal::_instance[propertyName];
    }

    override public function setValue(propertyName:String, value:*):void
    {
        if (model_internal::nonDerivedProperties.indexOf(propertyName) == -1)
        {
            throw new Error(propertyName + " is not a modifiable property of entity Table");
        }

        model_internal::_instance[propertyName] = value;
    }

    override public function getMappedByProperty(associationProperty:String):String
    {
        switch(associationProperty)
        {
            default:
            {
                return null;
            }
        }
    }

    override public function getPropertyLength(propertyName:String):int
    {
        switch(propertyName)
        {
            default:
            {
                return 0;
            }
        }
    }

    override public function isAvailable(propertyName:String):Boolean
    {
        if (model_internal::allProperties.indexOf(propertyName) == -1)
        {
            throw new Error(propertyName + " does not exist for entity Table");
        }

        if (model_internal::allAlwaysAvailableProperties.indexOf(propertyName) != -1)
        {
            return true;
        }

        switch(propertyName)
        {
            default:
            {
                return true;
            }
        }
    }

    override public function getIdentityMap():Object
    {
        var returnMap:Object = new Object();

        return returnMap;
    }

    [Bindable(event="propertyChange")]
    override public function get invalidConstraints():Array
    {
        if (model_internal::_instance.model_internal::_cacheInitialized_isValid)
        {
            return model_internal::_instance.model_internal::_invalidConstraints;
        }
        else
        {
            // recalculate isValid
            model_internal::_instance.model_internal::_isValid = model_internal::_instance.model_internal::calculateIsValid();
            return model_internal::_instance.model_internal::_invalidConstraints;        
        }
    }

    [Bindable(event="propertyChange")]
    override public function get validationFailureMessages():Array
    {
        if (model_internal::_instance.model_internal::_cacheInitialized_isValid)
        {
            return model_internal::_instance.model_internal::_validationFailureMessages;
        }
        else
        {
            // recalculate isValid
            model_internal::_instance.model_internal::_isValid = model_internal::_instance.model_internal::calculateIsValid();
            return model_internal::_instance.model_internal::_validationFailureMessages;
        }
    }

    override public function getDependantInvalidConstraints(propertyName:String):Array
    {
        var dependants:Array = getDependants(propertyName);
        if (dependants.length == 0)
        {
            return emptyArray;
        }

        var currentlyInvalid:Array = invalidConstraints;
        if (currentlyInvalid.length == 0)
        {
            return emptyArray;
        }

        var filterFunc:Function = function(element:*, index:int, arr:Array):Boolean
        {
            return dependants.indexOf(element) > -1;
        }

        return currentlyInvalid.filter(filterFunc);
    }

    /**
     * isValid
     */
    [Bindable(event="propertyChange")] 
    public function get isValid() : Boolean
    {
        if (model_internal::_instance.model_internal::_cacheInitialized_isValid)
        {
            return model_internal::_instance.model_internal::_isValid;
        }
        else
        {
            // recalculate isValid
            model_internal::_instance.model_internal::_isValid = model_internal::_instance.model_internal::calculateIsValid();
            return model_internal::_instance.model_internal::_isValid;
        }
    }

    [Bindable(event="propertyChange")]
    public function get isDefinitionAvailable():Boolean
    {
        return true;
    }

    [Bindable(event="propertyChange")]
    public function get isRowsAvailable():Boolean
    {
        return true;
    }


    /**
     * derived property recalculation
     */
    public function invalidateDependentOnDefinition():void
    {
        if (model_internal::_definitionIsValidCacheInitialized )
        {
            model_internal::_instance.model_internal::_doValidationCacheOfDefinition = null;
            model_internal::calculateDefinitionIsValid();
        }
    }
    public function invalidateDependentOnRows():void
    {
        if (model_internal::_rowsIsValidCacheInitialized )
        {
            model_internal::_instance.model_internal::_doValidationCacheOfRows = null;
            model_internal::calculateRowsIsValid();
        }
    }

    model_internal function fireChangeEvent(propertyName:String, oldValue:Object, newValue:Object):void
    {
        this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, propertyName, oldValue, newValue));
    }

    [Bindable(event="propertyChange")]   
    public function get definitionStyle():com.adobe.fiber.styles.Style
    {
        return model_internal::_nullStyle;
    }

    public function get definitionValidator() : StyleValidator
    {
        return model_internal::_definitionValidator;
    }

    model_internal function set _definitionIsValid_der(value:Boolean):void 
    {
        var oldValue:Boolean = model_internal::_definitionIsValid;         
        if (oldValue !== value)
        {
            model_internal::_definitionIsValid = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "definitionIsValid", oldValue, value));
        }                             
    }

    [Bindable(event="propertyChange")]
    public function get definitionIsValid():Boolean
    {
        if (!model_internal::_definitionIsValidCacheInitialized)
        {
            model_internal::calculateDefinitionIsValid();
        }

        return model_internal::_definitionIsValid;
    }

    model_internal function calculateDefinitionIsValid():void
    {
        var valRes:ValidationResultEvent = model_internal::_definitionValidator.validate(model_internal::_instance.definition)
        model_internal::_definitionIsValid_der = (valRes.results == null);
        model_internal::_definitionIsValidCacheInitialized = true;
        if (valRes.results == null)
             model_internal::definitionValidationFailureMessages_der = emptyArray;
        else
        {
            var _valFailures:Array = new Array();
            for (var a:int = 0 ; a<valRes.results.length ; a++)
            {
                _valFailures.push(valRes.results[a].errorMessage);
            }
            model_internal::definitionValidationFailureMessages_der = _valFailures;
        }
    }

    [Bindable(event="propertyChange")]
    public function get definitionValidationFailureMessages():Array
    {
        if (model_internal::_definitionValidationFailureMessages == null)
            model_internal::calculateDefinitionIsValid();

        return _definitionValidationFailureMessages;
    }

    model_internal function set definitionValidationFailureMessages_der(value:Array) : void
    {
        var oldValue:Array = model_internal::_definitionValidationFailureMessages;

        var needUpdate : Boolean = false;
        if (oldValue == null)
            needUpdate = true;
    
        // avoid firing the event when old and new value are different empty arrays
        if (!needUpdate && (oldValue !== value && (oldValue.length > 0 || value.length > 0)))
        {
            if (oldValue.length == value.length)
            {
                for (var a:int=0; a < oldValue.length; a++)
                {
                    if (oldValue[a] !== value[a])
                    {
                        needUpdate = true;
                        break;
                    }
                }
            }
            else
            {
                needUpdate = true;
            }
        }

        if (needUpdate)
        {
            model_internal::_definitionValidationFailureMessages = value;   
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "definitionValidationFailureMessages", oldValue, value));
            // Only execute calculateIsValid if it has been called before, to update the validationFailureMessages for
            // the entire entity.
            if (model_internal::_instance.model_internal::_cacheInitialized_isValid)
            {
                model_internal::_instance.model_internal::isValid_der = model_internal::_instance.model_internal::calculateIsValid();
            }
        }
    }

    [Bindable(event="propertyChange")]   
    public function get rowsStyle():com.adobe.fiber.styles.Style
    {
        return model_internal::_nullStyle;
    }

    public function get rowsValidator() : StyleValidator
    {
        return model_internal::_rowsValidator;
    }

    model_internal function set _rowsIsValid_der(value:Boolean):void 
    {
        var oldValue:Boolean = model_internal::_rowsIsValid;         
        if (oldValue !== value)
        {
            model_internal::_rowsIsValid = value;
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "rowsIsValid", oldValue, value));
        }                             
    }

    [Bindable(event="propertyChange")]
    public function get rowsIsValid():Boolean
    {
        if (!model_internal::_rowsIsValidCacheInitialized)
        {
            model_internal::calculateRowsIsValid();
        }

        return model_internal::_rowsIsValid;
    }

    model_internal function calculateRowsIsValid():void
    {
        var valRes:ValidationResultEvent = model_internal::_rowsValidator.validate(model_internal::_instance.rows)
        model_internal::_rowsIsValid_der = (valRes.results == null);
        model_internal::_rowsIsValidCacheInitialized = true;
        if (valRes.results == null)
             model_internal::rowsValidationFailureMessages_der = emptyArray;
        else
        {
            var _valFailures:Array = new Array();
            for (var a:int = 0 ; a<valRes.results.length ; a++)
            {
                _valFailures.push(valRes.results[a].errorMessage);
            }
            model_internal::rowsValidationFailureMessages_der = _valFailures;
        }
    }

    [Bindable(event="propertyChange")]
    public function get rowsValidationFailureMessages():Array
    {
        if (model_internal::_rowsValidationFailureMessages == null)
            model_internal::calculateRowsIsValid();

        return _rowsValidationFailureMessages;
    }

    model_internal function set rowsValidationFailureMessages_der(value:Array) : void
    {
        var oldValue:Array = model_internal::_rowsValidationFailureMessages;

        var needUpdate : Boolean = false;
        if (oldValue == null)
            needUpdate = true;
    
        // avoid firing the event when old and new value are different empty arrays
        if (!needUpdate && (oldValue !== value && (oldValue.length > 0 || value.length > 0)))
        {
            if (oldValue.length == value.length)
            {
                for (var a:int=0; a < oldValue.length; a++)
                {
                    if (oldValue[a] !== value[a])
                    {
                        needUpdate = true;
                        break;
                    }
                }
            }
            else
            {
                needUpdate = true;
            }
        }

        if (needUpdate)
        {
            model_internal::_rowsValidationFailureMessages = value;   
            this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "rowsValidationFailureMessages", oldValue, value));
            // Only execute calculateIsValid if it has been called before, to update the validationFailureMessages for
            // the entire entity.
            if (model_internal::_instance.model_internal::_cacheInitialized_isValid)
            {
                model_internal::_instance.model_internal::isValid_der = model_internal::_instance.model_internal::calculateIsValid();
            }
        }
    }


     /**
     * 
     * @inheritDoc 
     */ 
     override public function getStyle(propertyName:String):com.adobe.fiber.styles.IStyle
     {
         switch(propertyName)
         {
            default:
            {
                return null;
            }
         }
     }
     
     /**
     * 
     * @inheritDoc 
     *  
     */  
     override public function getPropertyValidationFailureMessages(propertyName:String):Array
     {
         switch(propertyName)
         {
            case("definition"):
            {
                return definitionValidationFailureMessages;
            }
            case("rows"):
            {
                return rowsValidationFailureMessages;
            }
            default:
            {
                return emptyArray;
            }
         }
     }

}

}
